import React, { Dispatch, SetStateAction, useState, useEffect } from "react";
import { TezosToolkit } from "@taquito/taquito";
import { BeaconWallet } from "@taquito/beacon-wallet";


const BuyButton = ({
    Tezos,
    FA2address,
    sender,
    receiver,
    amount
}: {
    Tezos: TezosToolkit,
    FA2address: string,
    sender: string,
    receiver: string,
    amount: number
}): JSX.Element => {
    
    const getTokenPrice = async (): Promise<void> => {
        const currency = "USD";
        if (currency == "USD") {
            
            const timestamp = new Date();
      timestamp.setDate(timestamp.getDate() - 1);
      const timestampString = timestamp.toISOString();
            fetch(`https://api.tzkt.io/v1/contracts/KT1F3BqwEAoa2koYX4Hz7zJ8xfGSxxAGVT8t/storage/history?limit=700`)
        .then(res => res.json())
        .then(data => data.find((item: any) => item.timestamp < timestampString))
        .then(item => {
          if (item && item.value) {
            console.log(item)  ;
            //const tez_pool = parseFloat(item.value.storage.tez_pool) / tezMultiplyer;
            //const token_pool = parseFloat(item.value.storage.token_pool) / tokenMultiplyer;
            //const price_yesterday = tez_pool / token_pool;
            //setTokenTezPriceYesterday(price_yesterday);
          }
        })
        }
    }
    
    const makePayment = async (): Promise<void> => {
	const contract = await Tezos.wallet.at(FA2address);
	
        const transfer_params = [
            {
                from_: sender,
                txs: [{
                    to_: receiver,
                    token_id:0,
                    amount: amount
                }]
            }
        ];
        
        const op = await contract.methods.transfer(transfer_params).send();
        await op.confirmation();
    }
    
    return (
        <div className="buttons">
            <button
	className="myButton"
	onClick={getTokenPrice}
	    >Transfer {amount}&nbsp;
	    µ-tokens from: &nbsp;
	    {sender}
	    &nbsp;to:&nbsp;
	    {receiver}
            </button>
        </div>
    );
};

export default BuyButton; 
